'use strict';

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var path = require('path');

var clear = function clear(p) {
  return p.replace('./', '').trim();
};

exports.onCreateWebpackConfig = function (_ref, pluginOptions) {
  var actions = _ref.actions,
      getConfig = _ref.getConfig;

  // get gatsby config
  var config = getConfig();
  var hasOptions = Object.keys(pluginOptions).filter(function (item) {
    return item !== 'plugins';
  }).length;

  // whether there is any option or not
  if (hasOptions) {
    var plugins = pluginOptions.plugins,
        options = _objectWithoutProperties(pluginOptions, ['plugins']);
    // get user specified root dir


    var rootDir = options.root || './';
    // build the root dir
    var contextSrc = path.join(config.context, clear(rootDir));
    // create an empty alias object
    var alias = {};

    // clear paths and add to the alias object
    Object.keys(options.alias).map(function (opt) {
      if (options.alias[opt].startsWith('./')) {
        alias[opt] = contextSrc + '/' + clear(options.alias[opt]);
      }
    });

    // set Webpack config
    actions.setWebpackConfig({
      resolve: {
        alias: alias
      }
    });
  }
};